;===========================================================================================
;
;       TX P/CONTROLE REMOTO DE 32 CANAIS COM PIC 16F877A
;
;       AUTOR : CLAUDIO LARIOS
;
;       DATA:04/04/2016
;
;       COM OPO DE PULSO OU RETENO
;       SAIDA NORMAL OU INVERTIDA
;
;       USE XTAL DE 4MHZ
;
;       USO DIDTICO
;       ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG LARIOS.TECNOLOGIA.WS
;===========================================================================================
;ARQUIVOS PARA COMPILAO
	LIST P=16f877a , R=DEC
    INCLUDE "P16F877a.INC" ;ARQUIVO PADRAO	
  	ERRORLEVEL      -302   ;ELIMINA MENSAGEM DE ERRO
;==============================================================================================================  
;PALAVRA DE CONFIGURAO
  __CONFIG		_CP_OFF & _PWRTE_ON & _WRT_OFF & _WDT_OFF  & _HS_OSC    & _BODEN_ON   & _LVP_OFF & _DEBUG_OFF
;===============================================================================================================	    
;TROCA DE BANCOS
#DEFINE		BANK0	BCF	STATUS,RP0 	;SETA BANK0 DE MEMORIA
#DEFINE		BANK1	BSF	STATUS,RP0	;SETA BANK1

    CBLOCK 0X20
  	RES5,RES4,RES3,RES2,RES1,RES0,RESX,TEMP,CNT,R7,R6,R5 
    ENDC
;===================================================================
; NMERO SERIAL
SERIAL_H     EQU 0CCH
SERIAL_L     EQU 0AAH
;===================================================================

;DEFINIES DE PINOS


#DEFINE SAIDA 0X09,2 ;PINO 10 RE2



	ORG 00H
INICIO:

    
; FALTA AQUI DESLIGAR COMPARADORES E CONVERSOR AD,LIGAR PULLUP DO PORTB ETC,...
    BANK1
    MOVLW   .7
    MOVWF   CMCON
    MOVLW  .7
    MOVWF  ADCON1
    CLRF   OPTION_REG  ;LIGA PULL UPS NO PORTB
  

    MOVLW  0XFF   ;PREPARA PORTAS PARA LEITURA DOS INTERRUPTORES 
    MOVWF  TRISA
    MOVWF  TRISB
    MOVWF  TRISC
    MOVWF  TRISD
    MOVLW  0X03
    MOVWF  TRISE ; SOMENTE RE2 COMO SADA
    BANK0
    CLRF   ADCON0
    CLRF   PORTE ; DESLIGA SAIDA

    MOVLW  SERIAL_H  ;NMERO SERIAL DO APARELHO
    MOVWF  RESX
    MOVLW  SERIAL_L
    MOVWF  RES0


    
    COMF  PORTA,W   ;INVERTE CONTEUDO EM 'W'
    ANDLW 0X3F    ;ZERA BITS 6 E 7
    MOVWF RES1
    COMF  PORTB,W   ;INVERTE CONTEUDO EM 'W'
    MOVWF RES2
    COMF  PORTC,W   ;INVERTE CONTEUDO EM 'W'
    MOVWF RES3
    COMF  PORTD,W   ;INVERTE CONTEUDO EM 'W'
    MOVWF RES4
    COMF  PORTE,W   ;INVERTE CONTEUDO EM 'W'
    ANDLW 0X03    ;ZERA BITS 2 A 7
    MOVWF TEMP
    MOVLW  .6
    MOVWF  CNT
LOOP1:
    BCF   STATUS,C  ;DESLOCA 6 CASAS PARA ESQUERDA
    RLF   TEMP,F
    DECFSZ CNT,F
    GOTO  LOOP1

    MOVFW TEMP
    IORWF RES1,F    ;BITS 0 E 1 DE RE VAI PARA RES1 6,7
 
    MOVFW  RES4
    ADDWF  RES3,W
    ADDWF  RES2,W
    ADDWF  RES1,W
    ADDWF  RES0,W
    ADDWF  RESX,W
    MOVWF  RES5       

    MOVFW  RES4      ;TESTA POR ALGUMA TECLA APERTADA
    BTFSS  STATUS,Z
    GOTO   SEG11
    MOVFW  RES3
    BTFSS  STATUS,Z
    GOTO   SEG11
    MOVFW  RES2
    BTFSS  STATUS,Z
    GOTO   SEG11
    MOVFW  RES1
    BTFSS  STATUS,Z
    GOTO   SEG11
    GOTO   INICIO   ;NENHUMA TECLA APERTADA
;=====================================================
;       TRANSMITIR
;======================================================

SEG11:

    CALL PAUSA_INIT
	CALL STARTBIT  ;ENVIA START BIT

	MOVLW .56    ;;QUANTIDADE DE BITS A TRANSMITIR
    MOVWF  R5
VOLT10:
	BCF   STATUS,C
    RRF   RES5,F
    RRF   RES4,F
    RRF   RES3,F
    RRF   RES2,F
    RRF   RES1,F
    RRF   RES0,F
    RRF   RESX,F
    BTFSS STATUS,C
    GOTO  ENV_0
    CALL  BIT1
    GOTO  DJ
ENV_0:
    CALL  BIT0

DJ:
    DECFSZ R5,F
    GOTO  VOLT10
    GOTO  INICIO

;=================================================
;ROTINAS

DELAY1CK:
      MOVLW .140
      MOVWF  R7
      DECFSZ R7,F
      GOTO   $-1
      RETURN

BIT0:
	BCF SAIDA
	CALL DELAY1CK
	BSF SAIDA
	CALL DELAY1CK
	CALL DELAY1CK
	BCF SAIDA
    RETURN


BIT1:
	BCF SAIDA
	CALL DELAY1CK
	CALL DELAY1CK
	BSF SAIDA
	CALL DELAY1CK
	BCF SAIDA
    RETURN



STARTBIT:
	BSF SAIDA
	CALL DELAY1CK
	BCF SAIDA
	RETURN



PAUSA_INIT:
    MOVLW .23    ;23 CLOCKS
    MOVWF  R6
RTY:
    CALL  DELAY1CK
    DECFSZ R6,F
    GOTO RTY
    RETURN

	END







































    END
